 addHook("PlayerThink", function(player)
	if player.charability == CA_FLY and player.panim == PA_ABILITY
		player.powers[pw_tailsfly] = 999999
	end
	if player.powers[pw_tailsfly] and player.pflags & PF_JUMPDOWN
		player.fly1 = 1
	end
	if (player.cmd.forwardmove > 0 or player.cmd.forwardmove < 0 or player.cmd.sidemove > 0 or player.cmd.sidemove < 0) and not (player.pflags & PF_SPINNING)
		player.mo.friction = FRACUNIT
	end
	if not (player.cmd.forwardmove > 0 or player.cmd.forwardmove < 0 or player.cmd.sidemove > 0 or player.cmd.sidemove < 0) and not (player.pflags & PF_SPINNING)
		player.mo.friction = 9*FRACUNIT/10
	end
	if player.speed > 72*FRACUNIT and not (player.powers[pw_sneakers] or player.powers[pw_super])
		player.mo.friction = 9*FRACUNIT/10
	end
	if player.speed > 120*FRACUNIT and (player.powers[pw_sneakers] or player.powers[pw_super])
		player.mo.friction = 9*FRACUNIT/10
	end
	if player.charflags & SF_DASHMODE and player.mo.eflags & MFE_UNDERWATER
		player.charflags = $ & ~SF_DASHMODE
	else
		player.charflags = $ | SF_DASHMODE
	end
	if player.charability == CA_JUMPTHOK and not (player.mo.eflags & MFE_UNDERWATER)
		player.actionspd = player.speed
	end
	if player.charability == CA_JUMPTHOK and player.mo.eflags & MFE_UNDERWATER
		player.actionspd = player.speed*2
	end
	if not (player.powers[pw_sneakers] or player.powers[pw_super]) and player.charability == CA_JUMPTHOK and player.actionspd > 72*FRACUNIT
		player.actionspd = 72*FRACUNIT
	end
	if (player.powers[pw_sneakers] or player.powers[pw_super]) and player.charability == CA_JUMPTHOK and player.actionspd > 120*FRACUNIT
		player.actionspd = 120*FRACUNIT
	end
	if player.charability == CA_JUMPTHOK and player.pflags & PF_THOKKED and not (player.pflags & PF_SHIELDABILITY)
		if player.mo.state != S_PLAY_JUMP
			player.mo.state = S_PLAY_JUMP
		end
		player.pflags = $ | PF_JUMPED
		player.pflags = $ | PF_SPINNING
		player.pflags = $ & ~PF_NOJUMPDAMAGE
	end
	if (player.powers[pw_sneakers] or player.powers[pw_super]) and not (player.mo.eflags & MFE_UNDERWATER) and player.pflags & PF_STARTDASH
		player.mindash = 60*FRACUNIT
		player.maxdash = 120*FRACUNIT
	end
	if not (player.powers[pw_sneakers] or player.powers[pw_super]) and not (player.mo.eflags & MFE_UNDERWATER) and player.pflags & PF_STARTDASH
		player.mindash = 36*FRACUNIT
		player.maxdash = 72*FRACUNIT
	end
	if (player.powers[pw_sneakers] or player.powers[pw_super]) and player.mo.eflags & MFE_UNDERWATER and player.pflags & PF_STARTDASH
		player.mindash = 30*FRACUNIT
		player.maxdash = 120*FRACUNIT
	end
	if not (player.powers[pw_sneakers] or player.powers[pw_super]) and player.mo.eflags & MFE_UNDERWATER and player.pflags & PF_STARTDASH
		player.mindash = 18*FRACUNIT
		player.maxdash = 72*FRACUNIT
	end
	if not (P_IsObjectOnGround(player.mo)) and ((player.charability == CA_FLY and player.panim == PA_ABILITY) or (player.charability == CA_FLOAT and player.pflags & PF_THOKKED and (player.panim == PA_WALK or player.panim == PA_RUN or player.panim == PA_DASH))) and (player.pflags & PF_USEDOWN and player.pflags & PF_JUMPDOWN)
		player.mo.state = S_PLAY_JUMP
		player.pflags = $ | PF_JUMPED
		player.pflags = $ & ~PF_THOKKED
	end
	if player.charability == CA_TWINSPIN and not (player.pflags & PF_STARTDASH or player.pflags & PF_SPINNING)
		player.charability2 = CA2_MELEE
		player.mindash = 2*FRACUNIT
		player.maxdash = 2*FRACUNIT
	end
	if player.mo.state == S_PLAY_MELEE_LANDING
		player.mo.friction = FRACUNIT
		if player.speed > 0 then
			player.mo.state = S_PLAY_WALK
		end
		if player.speed == 0 then
			player.mo.state = S_PLAY_STND
		end
		if player.pflags & PF_USEDOWN and not (player.pflags & PF_JUMPDOWN) and player.speed >= 5*FRACUNIT
			player.mo.state = S_PLAY_ROLL
			player.pflags = $ | PF_SPINNING
			S_StartSound(player.mo, sfx_spin)
		end
		if player.pflags & PF_USEDOWN and not (player.pflags & PF_JUMPDOWN) and player.speed < 5*FRACUNIT
			player.charability2 = CA2_SPINDASH
			player.mo.state = S_PLAY_SPINDASH
			player.pflags = $ | PF_SPINNING
			player.pflags = $ | PF_STARTDASH
			S_StartSound(player.mo, sfx_spndsh)
		end
		if (player.pflags & PF_JUMPDOWN and not (player.pflags & PF_USEDOWN)) or (player.pflags & PF_STARTJUMP and player.pflags & PF_SPINNING)
			player.mo.state = S_PLAY_ROLL
			player.pflags = $ | PF_STARTJUMP
			player.pflags = $ | PF_JUMPED
			player.pflags = $ & ~PF_NOJUMPDAMAGE
			S_StartSound(player.mo, sfx_jump)
			if not (mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS) and not (player.mo.eflags & MFE_UNDERWATER)
				P_SetObjectMomZ(player.mo, (39*player.jumpfactor)/4, false)
			end
			if mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS and not (player.mo.eflags & MFE_UNDERWATER)
				P_SetObjectMomZ(player.mo, 18*player.jumpfactor, false)
			end
			if not (mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS) and player.mo.eflags & MFE_UNDERWATER
				P_SetObjectMomZ(player.mo, (23*player.jumpfactor)/4, false)
			end
			if mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS and player.mo.eflags & MFE_UNDERWATER
				P_SetObjectMomZ(player.mo, (21*player.jumpfactor)/2, false)
			end
		end
	end
	if (player.mo.state == S_PLAY_FIRE or player.mo.state == S_PLAY_FIRE_FINISH or player.airgun == true) and player.weapondelay
		player.mo.momx = player.lastmomx
		player.mo.momy = player.lastmomy
	end
	if (player.mo.state == S_PLAY_FIRE or player.mo.state == S_PLAY_FIRE_FINISH) and not player.weapondelay
		if player.speed > 0 then
			player.mo.state = S_PLAY_WALK
			player.mo.momx = player.lastmomx
			player.mo.momy = player.lastmomy
		end
		if player.speed == 0 then
			player.mo.state = S_PLAY_STND
		end
	end
	if player.airgun == true and player.weapondelay
		player.mo.momx = player.lastmomx
		player.mo.momy = player.lastmomy
	end
	if player.airgun == true and not player.weapondelay and not (player.pflags & PF_BOUNCING)
		player.mo.state = S_PLAY_JUMP
		player.pflags = $ | PF_JUMPED
		player.pflags = $ | PF_NOJUMPDAMAGE
		player.pflags = $ & ~PF_THOKKED
		player.pflags = $ & ~PF_USEDOWN
	end
	if not P_IsObjectOnGround(player.mo) and (player.panim == PA_WALK or player.panim == PA_RUN or player.panim == PA_PAIN or (player.panim == PA_DASH and not (player.pflags & PF_THOKKED)) or player.panim == PA_SPRING or player.panim == PA_FALL or (player.charflags & SF_NOJUMPSPIN and player.panim == PA_JUMP)) and not ((player.mo.state == S_PLAY_FLOAT or player.mo.state == S_PLAY_FLOAT_RUN) and player.pflags & PF_THOKKED) and not (not (player.pflags & PF_BOUNCING) and player.bouncelast) and not player.glidelast and not (player.charability == CA_FLOAT and player.pflags & PF_THOKKED and (player.panim == PA_FALL or player.panim == PA_SPRING) and not (player.pflags & PF_SHIELDABILITY)) and P_PlayerInPain(player) == false
		if player.mo.momz > 0 and not (player.mo.eflags & MFE_VERTICALFLIP)
			player.mo.state = S_PLAY_SPRING
			player.pflags = $ | PF_JUMPED
			player.pflags = $ | PF_NOJUMPDAMAGE
			player.pflags = $ & ~PF_THOKKED
		end
		if player.mo.momz <= 0 and not (player.mo.eflags & MFE_VERTICALFLIP)
			player.mo.state = S_PLAY_FALL
			player.pflags = $ | PF_JUMPED
			player.pflags = $ | PF_NOJUMPDAMAGE
			player.pflags = $ & ~PF_THOKKED
		end
		if player.mo.eflags & MFE_VERTICALFLIP and player.mo.momz < 0
			player.mo.state = S_PLAY_SPRING
			player.pflags = $ | PF_JUMPED
			player.pflags = $ | PF_NOJUMPDAMAGE
			player.pflags = $ & ~PF_THOKKED
		end
		if player.mo.eflags & MFE_VERTICALFLIP and player.mo.momz >= 0
			player.mo.state = S_PLAY_FALL
			player.pflags = $ | PF_JUMPED
			player.pflags = $ | PF_NOJUMPDAMAGE
			player.pflags = $ & ~PF_THOKKED
		end
	end
	if player.pflags & PF_SHIELDABILITY and player.mo.state != S_PLAY_JUMP
		player.mo.state = S_PLAY_JUMP
	end
--Glide & Bounce Momentum Code by Frostiikin
	if player.charability == CA_GLIDEANDCLIMB
		if player.glidelast == nil
			player.glidelast = 0
		end
		local gliding = player.pflags & PF_GLIDING
		local thokked = player.pflags & PF_THOKKED
		local exitglide = (player.glidelast == 1 and not (gliding) and thokked)
		local landglide = (player.glidelast == 2 and not (gliding|thokked))
		if exitglide or landglide
			player.mo.momx = player.lastmomx
			player.mo.momy = player.lastmomy
		end
		if exitglide and player.panim != PA_JUMP
			player.mo.state = S_PLAY_JUMP
			player.pflags = $ | PF_JUMPED
			player.pflags = $ & ~PF_NOJUMPDAMAGE
			player.pflags = $ & ~PF_THOKKED
		end
		if gliding
			player.glidelast = 1
		elseif exitglide
			player.glidelast = 2
		elseif not(gliding|thokked)
			player.glidelast = 0
		end
	end
	if player.charability == CA_BOUNCE
		if player.bouncelast == nil
			player.bouncelast = false
		end
		if player.pflags & PF_BOUNCING and not (player.bouncelast) and player.panim != PA_PAIN
		or (not (player.pflags & PF_BOUNCING) and player.bouncelast) and player.panim != PA_PAIN
			player.mo.momx = player.lastmomx
			player.mo.momy = player.lastmomy
			if (not (player.pflags & PF_BOUNCING) and player.bouncelast)
				player.mo.state = S_PLAY_JUMP
				player.pflags = $ | PF_JUMPED
				player.pflags = $ | PF_NOJUMPDAMAGE
				player.pflags = $ & ~PF_THOKKED
			end
		end
		player.bouncelast = (player.pflags & PF_BOUNCING > 0)
	end
	player.lastmomx = player.mo.momx
	player.lastmomy = player.mo.momy
end)
-- Repurposed Spam Dash Code by Starlight
local function Uncurl(player)
	if (player.speed > 5*FRACUNIT and player.pflags & PF_STARTDASH) then return true end
	if P_IsObjectOnGround(player.mo) and player.pflags & PF_SPINNING and player.mo.state == S_PLAY_ROLL and not (player.pflags & (PF_USEDOWN|PF_STARTDASH)) then
		player.mo.state = S_PLAY_WALK
		player.pflags = ($ & ~PF_SPINNING) | PF_USEDOWN
		return true
    end
end
addHook("SpinSpecial", Uncurl)
--Repurposed Egg Reverie Flight Code by Fyrid19
addHook("ThinkFrame", function()
	for player in players.iterate do
		if not (player.mo and (player.mo.skin == "metalsonic")) then return end
		if not (player.cmd.buttons & BT_JUMP) then
			player.c1ready = true
			player.c1 = false
		elseif player.c1ready then
			player.c1 = true
			player.c1ready = false
		else
			player.c1 = false
		end
		if not (player.cmd.buttons & BT_USE) then
			player.c2ready = true
			player.c2 = false
		elseif player.c2ready then
			player.c2 = true
			player.c2ready = false
		else
			player.c2 = false
		end
		if (player.powers[pw_super] or player.mo.skin == "metalsonic")
			if player.flying and player.cmd.buttons & BT_USE and player.cmd.buttons & BT_JUMP and (player.secondjump == 1 or player.secondjump == 2)
				player.flying = false
				player.secondjump = 0
			elseif not player.flying and not P_IsObjectOnGround(player.mo) and player.pflags & PF_THOKKED and player.c1
				player.flying = true
			end
		end
		if not (player.powers[pw_super] or player.mo.skin == "metalsonic")
		and player.flying
			player.flying = false
		end
		if player.flying == nil
			player.flying = false
		end
		if P_IsObjectOnGround(player.mo)
			player.flying = false
		end
		if player.flying and (player.secondjump == 1 or player.secondjump == 2)
			if (player.cmd.buttons & BT_JUMP) and not (player.cmd.buttons & BT_USE)
				if player.mo.momz < 9*FRACUNIT/2
					player.mo.momz = $ + 2*FRACUNIT
				elseif player.mo.momz >= 9*FRACUNIT/2
					player.mo.momz = 9*FRACUNIT/2
				elseif player.mo.momz < 0
					player.mo.momz = 0
				end
			elseif (player.cmd.buttons & BT_USE) and not (player.cmd.buttons & BT_JUMP)
				if player.mo.momz > -9*FRACUNIT/2
					player.mo.momz = $ - 1*FRACUNIT
				elseif player.mo.momz <= -9*FRACUNIT/2
					player.mo.momz = -9*FRACUNIT/2
				elseif player.mo.momz > 0
					player.mo.momz = 0
				end
			elseif not ((player.cmd.buttons & BT_USE) or (player.cmd.buttons & BT_JUMP))
				player.mo.momz = 0
			end
			if player.dashmode < 3*TICRATE
				player.pflags = $ | PF_NOJUMPDAMAGE
			end
			if player.dashmode >= 3*TICRATE
				player.pflags = $ & ~PF_NOJUMPDAMAGE
			end
			if (player.mo.skin == "metalsonic")
				if player.speed >= player.runspeed and (player.dashmode < 3*TICRATE or player.mo.skin != "metalsonic")
					player.mo.state = S_PLAY_FLOAT_RUN
				end
				if player.speed >= player.runspeed and player.dashmode >= 3*TICRATE and player.mo.skin == "metalsonic"
					player.mo.state = S_PLAY_DASH
				end
				if player.speed < player.runspeed
					player.mo.state = S_PLAY_FLOAT
				end
			end
			player.pflags = $|PF_JUMPED|PF_THOKKED
		end
	end
end)